/[gentoo-x86]/eclass/gtk-sharp-module.eclass
Gentoo

Diff of /eclass/gtk-sharp-module.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.9 Revision 1.25
1# Copyright 1999-2008 Gentoo Foundation 1# Copyright 1999-2008 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/gtk-sharp-module.eclass,v 1.9 2009/01/05 20:49:10 loki_val Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/gtk-sharp-module.eclass,v 1.25 2009/08/23 00:14:31 loki_val Exp $
4 4
5# Author : Peter Johanson <latexer@gentoo.org>, butchered by ikelos, then loki_val. 5# @ECLASS: gtk-sharp-module.eclass
6# Based off of original work in gst-plugins.eclass by <foser@gentoo.org> 6# @MAINTAINER:
7# dotnet@gentoo.org
8# @BLURB: Manages the modules of the gtk-, gnome-, and gnome-desktop-sharp tarballs
9# @DESCRIPTION:
10# This eclass provides phase functions and helper functions for the modules
11# of the gtk-sharp, gnome-sharp and gnome-desktop-sharp tarballs.
12# PLEASE TAKE NOTE: ONLY FOR EAPI-2 EBUILDS
7 13
8# Note that this breaks compatibility with the original gtk-sharp-component 14WANT_AUTOMAKE=none
9# eclass. 15WANT_AUTOCONF=none
10 16
11inherit eutils mono multilib autotools base versionator 17inherit eutils mono multilib libtool autotools base versionator
12 18
13# Get the name of the component to build and the build dir; by default, 19# @ECLASS-VARIABLE: GTK_SHARP_MODULE
14# extract it from the ebuild's name. 20# @DESCRIPTION:
21# The name of the Gtk# module.
22# Default value: ${PN/-sharp/}
15GTK_SHARP_MODULE=${GTK_SHARP_MODULE:=${PN/-sharp/}} 23GTK_SHARP_MODULE=${GTK_SHARP_MODULE:=${PN/-sharp/}}
24
25# @ECLASS-VARIABLE: GTK_SHARP_MODULE_DIR
26# @DESCRIPTION:
27# The subdirectory of S in which GTK_SHARP_MODULE is installed.
28# Default value: ${PN/-sharp/}
16GTK_SHARP_MODULE_DIR=${GTK_SHARP_MODULE_DIR:=${PN/-sharp/}} 29GTK_SHARP_MODULE_DIR=${GTK_SHARP_MODULE_DIR:=${PN/-sharp/}}
17 30
18# Allow ebuilds to set a value for the required GtkSharp version. 31# @ECLASS-VARIABLE: GTK_SHARP_REQUIRED_VERSION
32# @DESCRIPTION:
33# The version of the gtk-sharp tarball this package requires.
34# Optional.
19GTK_SHARP_REQUIRED_VERSION=${GTK_SHARP_REQUIRED_VERSION} 35GTK_SHARP_REQUIRED_VERSION="${GTK_SHARP_REQUIRED_VERSION}"
20 36
21# Version number used to differentiate between unversioned 1.0 series and the 37# @ECLASS-VARIABLE: gapi_users_list
22# versioned 2.0 series (2.0 series has 2 or 2.0 appended to various paths and 38# @DESCRIPTION:
23# scripts). Default to ${SLOT}. 39# List of modules that use one of gapi2-codegen, gapi2-fixup or gapi2-parser
24GTK_SHARP_SLOT="${GTK_SHARP_SLOT:=${SLOT}}" 40# No ebuild-serviceable parts inside.
25GTK_SHARP_SLOT_DEC="${GTK_SHARP_SLOT_DEC:=-${GTK_SHARP_SLOT}.0}" 41gapi_users_list="art gnome gnomevfs ${gnome_desktop_sharp_module_list} atk gtk gdk glade pango"
26 42
27#Handy little var 43# @ECLASS-VARIABLE: PV_MAJOR
44# @DESCRIPTION:
45# The first two components of the PV variable.
28PV_MAJOR=$(get_version_component_range 1-2) 46PV_MAJOR=$(get_version_component_range 1-2)
29 47
30# Set some defaults. 48# @FUNCTION: add_bdepend
31DESCRIPTION="GtkSharp's ${GTK_SHARP_MODULE} module" 49# @USAGE: <package atom>
32HOMEPAGE="http://www.mono-project.com/GtkSharp" 50# @DESCRIPTION:
33 51# Adds to the DEPEND variable
34LICENSE="LGPL-2.1"
35DEPEND="
36 >=dev-lang/mono-2.0.1
37 >=sys-apps/sed-4
38 >=dev-util/pkgconfig-0.23
39 "
40RDEPEND="
41 >=dev-lang/mono-2.0.1
42 "
43
44IUSE="debug"
45
46
47# The GtkSharp modules are currently divided into three seperate tarball
48# distributions. Figure out which of these our component belongs to.
49
50gtk_sharp_module_list="glib glade gtk gdk atk pango gtk-dotnet gtk-gapi"
51gnome_sharp_module_list="art gnome gnomevfs gconf"
52gnome_desktop_sharp_module_list="gnome-desktop gnome-print gnome-panel gtkhtml gtksourceview nautilusburn rsvg vte wnck"
53
54has "${GTK_SHARP_MODULE}" ${gtk_sharp_module_list} && GTK_SHARP_REQUIRED_VERSION=${PV}
55
56
57add_bdepend() { 52add_bdepend() {
53 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs ONE (1) argument"
58 DEPEND="${DEPEND} $@" 54 DEPEND="${DEPEND} $@"
59} 55}
60 56
57# @FUNCTION: add_rdepend
58# @USAGE: <package atom>
59# @DESCRIPTION:
60# Adds to the RDEPEND variable
61add_rdepend() { 61add_rdepend() {
62 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs ONE (1) argument"
62 RDEPEND="${RDEPEND} $@" 63 RDEPEND="${RDEPEND} $@"
63} 64}
64 65
66# @FUNCTION: add_depend
67# @USAGE: <package atom>
68# @DESCRIPTION:
69# Adds to the DEPEND and RDEPEND variables
65add_depend() { 70add_depend() {
71 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs ONE (1) argument"
66 DEPEND="${DEPEND} $@" 72 DEPEND="${DEPEND} $@"
67 RDEPEND="${RDEPEND} $@" 73 RDEPEND="${RDEPEND} $@"
68} 74}
69 75
70gsm_get_tarball() { 76# @ECLASS-VARIABLE: TARBALL
71 has "${GTK_SHARP_MODULE}" ${gtk_sharp_module_list} \ 77# @DESCRIPTION:
72 && echo "gtk-sharp" && return 0 78# The GtkSharp modules are currently divided into three seperate tarball
73 has "${GTK_SHARP_MODULE}" ${gnome_sharp_module_list} \ 79# distributions. The TARBALL variable holds the name of the tarball
74 && echo "gnome-sharp" && return 0 80# to which GTK_SHARP_MODULE belongs.
75 has "${GTK_SHARP_MODULE}" ${gnome_desktop_sharp_module_list} \ 81case ${GTK_SHARP_MODULE} in
76 && echo "gnome-desktop-sharp" && return 0 82 glib|glade|gtk|gdk|atk|pango|gtk-dotnet|gtk-gapi|gtk-docs)
77 die "unknown GtkSharp module: ${GTK_SHARP_MODULE}" 83 TARBALL="gtk-sharp"
78} 84 case ${PVR} in
79 85 2.12.*)
80[[ "${PN}" != "gtk-sharp-gapi" ]] && add_bdepend "=dev-dotnet/gtk-sharp-gapi-${GTK_SHARP_REQUIRED_VERSION}*" 86 SRC_URI="mirror://gentoo/${TARBALL}-2.12.7.patch.bz2"
81has "${GTK_SHARP_MODULE}" ${gnome_sharp_module_list} ${gnome_desktop_sharp_module_list} gtk-dotnet glade \ 87 #Upstream: https://bugzilla.novell.com/show_bug.cgi?id=$bugno
88 #Upstream bug #470390 for the gtk-sharp-2.12.7.patch
89 PATCHES=(
90 "${WORKDIR}/${TARBALL}-2.12.7.patch"
91 )
92 EAUTORECONF="YES"
93 add_bdepend "=sys-devel/automake-1.10*"
94 add_bdepend ">=sys-devel/autoconf-2.61"
95 ;;
96 esac
97 ;;
98 art|gnome|gnomevfs|gconf)
99 TARBALL="gnome-sharp"
82 && add_depend "=dev-dotnet/gtk-sharp-${GTK_SHARP_REQUIRED_VERSION}*" 100 add_depend "=dev-dotnet/gtk-sharp-${GTK_SHARP_REQUIRED_VERSION}*"
83has "${GTK_SHARP_MODULE}" gtk gdk atk pango gtk-dotnet parser \ 101 has "${GTK_SHARP_MODULE}" "${gapi_users_list}" && \
102 add_bdepend "=dev-dotnet/gtk-sharp-gapi-${GTK_SHARP_REQUIRED_VERSION}*"
103 case ${PVR} in
104 2.24.1*)
105 SRC_URI="mirror://gentoo/${TARBALL}-2.24.1.patch.bz2"
106 # Upstream bug: https://bugzilla.novell.com/show_bug.cgi?id=483251
107 PATCHES=(
108 "${WORKDIR}/${TARBALL}-2.24.1.patch"
109 )
110 EAUTORECONF="YES"
111 add_bdepend "=sys-devel/automake-1.10*"
112 add_bdepend ">=sys-devel/autoconf-2.61"
113 ;;
114 esac
115 ;;
116 gnome-desktop|gnome-print|gnome-panel|gtkhtml|gtksourceview|nautilusburn|rsvg|vte|wnck)
117 TARBALL="gnome-desktop-sharp"
84 && add_depend "=dev-dotnet/glib-sharp-${GTK_SHARP_REQUIRED_VERSION}*" 118 add_depend "=dev-dotnet/gtk-sharp-${GTK_SHARP_REQUIRED_VERSION}*"
85has "${GTK_SHARP_MODULE}" ${gnome_desktop_sharp_module_list} \
86 && add_depend ">=dev-dotnet/gnome-sharp-${PV_MAJOR}" 119 add_depend "=dev-dotnet/gnome-sharp-2.24*"
120 add_bdepend "=dev-dotnet/gtk-sharp-gapi-${GTK_SHARP_REQUIRED_VERSION}*"
121 ;;
122 *)
123 eerror "Huh? Sonny boy, looks like your GTK_SHARP_MODULE is not on the approved list. BAILING!"
124 die "How did we get here!!?"
125 ;;
126esac
87 127
88case ${PF} in 128case ${PF} in
89 #gtk-sharp tarball 129 #gtk-sharp tarball
130 gtk-sharp-docs*)
131 add_depend ">=virtual/monodoc-2.0"
132 ;;
90 gtk-sharp-gapi*) 133 gtk-sharp-gapi*)
134 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
91 add_depend "dev-perl/XML-LibXML" 135 add_depend "dev-perl/XML-LibXML"
92 ;; 136 ;;
93 gtk-sharp-*) 137 gtk-sharp-*)
138 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
139 add_depend "~dev-dotnet/glib-sharp-${PV}"
94 add_depend "~dev-dotnet/atk-sharp-${PV}" 140 add_depend "~dev-dotnet/atk-sharp-${PV}"
95 add_depend "~dev-dotnet/gdk-sharp-${PV}" 141 add_depend "~dev-dotnet/gdk-sharp-${PV}"
96 add_depend "~dev-dotnet/pango-sharp-${PV}" 142 add_depend "~dev-dotnet/pango-sharp-${PV}"
97 ;; 143 ;;
98 gdk-sharp-*) 144 gdk-sharp-*)
99 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2" 145 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
146 add_depend "~dev-dotnet/glib-sharp-${PV}"
100 add_depend "x11-libs/gtk+:2" 147 add_depend "x11-libs/gtk+:2"
101 add_depend "~dev-dotnet/pango-sharp-${PV}" 148 add_depend "~dev-dotnet/pango-sharp-${PV}"
149 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
102 ;; 150 ;;
103 atk-sharp-*) 151 atk-sharp-*)
152 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
153 add_depend "~dev-dotnet/glib-sharp-${PV}"
154 add_depend "dev-libs/atk"
104 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2" 155 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
105 add_depend "dev-libs/atk"
106 ;; 156 ;;
107 glib-sharp-*) 157 glib-sharp-*)
108 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2" 158 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
109 add_depend "dev-libs/glib:2" 159 add_depend "dev-libs/glib:2"
110 ;; 160 ;;
111 pango-sharp-*) 161 pango-sharp-*)
162 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
163 add_depend "~dev-dotnet/glib-sharp-${PV}"
164 add_depend "x11-libs/pango"
112 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2" 165 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
113 add_depend "x11-libs/pango"
114 ;; 166 ;;
115 gtk-dotnet-*) 167 gtk-dotnet-*)
116 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2" 168 add_depend "~dev-dotnet/glib-sharp-${PV}"
117 add_depend "~dev-dotnet/gdk-sharp-${PV}" 169 add_depend "~dev-dotnet/gdk-sharp-${PV}"
118 add_depend "~dev-dotnet/pango-sharp-${PV}" 170 add_depend "~dev-dotnet/pango-sharp-${PV}"
171 add_depend "~dev-dotnet/gtk-sharp-${PV}"
119 add_depend "!dev-lang/mono[minimal]" 172 add_depend "dev-lang/mono[-minimal]"
173 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
120 ;; 174 ;;
121 glade-sharp-*) 175 glade-sharp-*)
176 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
177 add_depend "~dev-dotnet/glib-sharp-${PV}"
122 add_depend "~dev-dotnet/atk-sharp-${PV}" 178 add_depend "~dev-dotnet/atk-sharp-${PV}"
123 add_depend "~dev-dotnet/gdk-sharp-${PV}" 179 add_depend "~dev-dotnet/gdk-sharp-${PV}"
180 add_depend "~dev-dotnet/gtk-sharp-${PV}"
124 add_depend "~dev-dotnet/pango-sharp-${PV}" 181 add_depend "~dev-dotnet/pango-sharp-${PV}"
125 add_depend ">=gnome-base/libglade-2.3.6" 182 add_depend ">=gnome-base/libglade-2.3.6"
126 ;; 183 ;;
127 #gnome-sharp tarball 184 #gnome-sharp tarball
128 art-sharp-*) 185 art-sharp-*)
129 add_depend ">=media-libs/libart_lgpl-2.3.20" 186 add_depend ">=media-libs/libart_lgpl-2.3.20"
130 ;; 187 ;;
131 gnome-sharp-*) 188 gnome-sharp-*)
132 add_depend ">=gnome-base/libgnomeui-${PV_MAJOR}" 189 add_depend ">=gnome-base/libgnomeui-${PV_MAJOR}"
133 add_depend ">=gnome-base/gnome-panel-${PV_MAJOR}"
134 add_depend "~dev-dotnet/gnomevfs-sharp-${PV}" 190 add_depend "~dev-dotnet/gnomevfs-sharp-${PV}"
135 add_depend "~dev-dotnet/art-sharp-${PV}" 191 add_depend "~dev-dotnet/art-sharp-${PV}"
136 add_depend ">=gnome-base/libgnomecanvas-${GNOMECANVAS_REQUIRED_VERSION}" 192 add_depend ">=gnome-base/libgnomecanvas-${GNOMECANVAS_REQUIRED_VERSION}"
193 add_depend ">=x11-libs/gtk+-2.14.0"
137 ;; 194 ;;
138 gconf-sharp-*) 195 gconf-sharp-*)
139 add_depend ">=gnome-base/gconf-${PV_MAJOR}" 196 add_depend ">=gnome-base/gconf-${PV_MAJOR}"
140 add_depend ">=dev-dotnet/glade-sharp-${GTK_SHARP_REQUIRED_VERSION}" 197 add_depend "=dev-dotnet/glade-sharp-${GTK_SHARP_REQUIRED_VERSION}*"
141 add_depend "~dev-dotnet/gnome-sharp-${PV}" 198 add_depend "~dev-dotnet/gnome-sharp-${PV}"
142 add_depend "~dev-dotnet/art-sharp-${PV}" 199 add_depend "~dev-dotnet/art-sharp-${PV}"
143 ;; 200 ;;
144 gnomevfs-sharp-*) 201 gnomevfs-sharp-*)
145 add_depend ">=gnome-base/gnome-vfs-${PV_MAJOR}" 202 add_depend ">=gnome-base/gnome-vfs-${PV_MAJOR}"
146 ;; 203 ;;
147 #gnome-desktop-sharp tarball 204 #gnome-desktop-sharp tarball
148 gnome-desktop-sharp-*) 205 gnome-desktop-sharp-*)
206 # NOTE: libgnome-desktop-2.so has been known to make binary-
207 # incompatible changes, requiring .so bumps. gnome-desktop-sharp
208 # is locked to a specific .so.n version, so strict dependencies
209 # may be required in the future (as it has in the past).
149 add_depend "=gnome-base/gnome-desktop-${PV_MAJOR}*" 210 add_depend ">=gnome-base/gnome-desktop-${PV_MAJOR}"
150 ;; 211 ;;
151 gnome-panel-sharp-*) 212 gnome-panel-sharp-*)
152 add_depend "=gnome-base/gnome-panel-${PV_MAJOR}*" 213 add_depend ">=gnome-base/gnome-panel-${PV_MAJOR}"
153 ;; 214 ;;
154 gnome-print-sharp-*) 215 gnome-print-sharp-*)
155 add_depend ">=gnome-base/libgnomeprint-${API_VERSION}" 216 add_depend ">=gnome-base/libgnomeprint-${API_VERSION}"
156 ;; 217 ;;
157 gtkhtml-sharp-*) 218 gtkhtml-sharp-*)
163 ;; 224 ;;
164 gtksourceview-sharp-*) 225 gtksourceview-sharp-*)
165 add_depend ">=x11-libs/gtksourceview-${GTKSOURCEVIEW_REQUIRED_VERSION}:2.0" 226 add_depend ">=x11-libs/gtksourceview-${GTKSOURCEVIEW_REQUIRED_VERSION}:2.0"
166 ;; 227 ;;
167 nautilusburn-sharp-*) 228 nautilusburn-sharp-*)
168 add_depend ">=gnome-extra/nautilus-cd-burner-${PV_MAJOR}" 229 add_depend ">=gnome-extra/nautilus-cd-burner-2.24.0"
169 ;; 230 ;;
170 rsvg-sharp-*) 231 rsvg-sharp-*)
171 add_depend ">=gnome-base/librsvg-${RSVG_REQUIRED_VERSION}" 232 add_depend ">=gnome-base/librsvg-${RSVG_REQUIRED_VERSION}"
172 ;; 233 ;;
173 vte-sharp-*) 234 vte-sharp-*)
176 wnck-sharp-*) 237 wnck-sharp-*)
177 add_depend ">=x11-libs/libwnck-${PV_MAJOR}" 238 add_depend ">=x11-libs/libwnck-${PV_MAJOR}"
178 ;; 239 ;;
179esac 240esac
180 241
242# @ECLASS-VARIABLE: DESCRIPTION
243# @DESCRIPTION:
244# Default value: GtkSharp's ${GTK_SHARP_MODULE} module of the ${TARBALL} tarball
245DESCRIPTION="GtkSharp's ${GTK_SHARP_MODULE} module of the ${TARBALL} tarball"
246# @ECLASS-VARIABLE: HOMEPAGE
247# @DESCRIPTION:
248# Default value: http://www.mono-project.com/GtkSharp
249HOMEPAGE="http://www.mono-project.com/GtkSharp"
250# @ECLASS-VARIABLE: DESCRIPTION
251# @DESCRIPTION:
252# Default value: LGPL-2.1
253LICENSE="LGPL-2.1"
181 254
255add_depend ">=dev-lang/mono-2.0.1"
256add_bdepend ">=sys-apps/sed-4"
257add_bdepend ">=dev-util/pkgconfig-0.23"
258add_bdepend ">=app-shells/bash-3.1"
182 259
183GSM_P=$(gsm_get_tarball)-${PV} 260IUSE="debug"
184S=${WORKDIR}/${GSM_P} 261# @ECLASS-VARIABLE: S
185SRC_URI="mirror://gnome/sources/$(gsm_get_tarball)/${PV%.*}/${GSM_P}.tar.bz2" 262# @DESCRIPTION:
186 263# Default value: ${WORKDIR}/${TARBALL}-${PV}
187if [[ "${GSM_P%.*}" = "gtk-sharp-2.12" ]] 264S="${WORKDIR}/${TARBALL}-${PV}"
188then 265# @ECLASS-VARIABLE: SRC_URI
266# @DESCRIPTION:
267# Default value: mirror://gnome/sources/${TARBALL}/${PV_MAJOR}/${TARBALL}-${PV}.tar.bz2
189 SRC_URI="${SRC_URI} 268SRC_URI="${SRC_URI}
190 mirror://gentoo/gtk-sharp-2.12.0-patches.tar.bz2" 269 mirror://gnome/sources/${TARBALL}/${PV_MAJOR}/${TARBALL}-${PV}.tar.bz2"
191 #Upstream: https://bugzilla.novell.com/show_bug.cgi?id=$bugno 270
192 #Upstream bug #421063 271# @FUNCTION: get_sharp_apis
193 PATCHES=( "${WORKDIR}/patches/$(gsm_get_tarball)-2.12.0-parallelmake.patch" 272# @USAGE: <type> <pkgconfig-package>
194 "${WORKDIR}/patches/$(gsm_get_tarball)-2.12.0-doc-parallelmake.patch" ) 273# @RETURN: .NET API files
195 EAUTORECONF="YES" 274# @DESCRIPTION:
275# Given a valid pkg-config package, will return a list of API xml files.
276# <type> can be either --prefixed or --bare. If prefixed, each API file
277# will be prefixed with -I:
278get_sharp_apis() {
279 [[ ${#@} -eq 2 ]] || die "${FUNCNAME} needs two arguments"
280 get_sharp_assemblies "$@"
281}
282
283# @FUNCTION: get_sharp_assemblies
284# @USAGE: <type> <pkgconfig-package>
285# @RETURN: .NET .dll assemblies
286# @DESCRIPTION:
287# Given a valid pkg-config package, will return a list of .dll assemblies.
288# <type> can be either --prefixed or --bare. If prefixed, each .dll file
289# will be prefixed with -r:
290get_sharp_assemblies() {
291 [[ ${#@} -eq 2 ]] || die "${FUNCNAME} needs two arguments"
292 local string config=libs prefix="-r:"
293 local -a rvalue
294 [[ "${FUNCNAME[1]}" = "get_sharp_apis" ]] && config=cflags && prefix="-I:"
295 for string in $(pkg-config --${config} ${2} 2> /dev/null)
296 do
297 rvalue+=( ${string#-?:} )
298 done
299
300 case $1 in
301 --bare)
302 :
303 ;;
304 --prefixed)
305 for (( i=0 ; i< ${#rvalue[@]} ; i++ ))
306 do
307 rvalue[$i]=${prefix}${rvalue[$i]}
308 done
309 ;;
310 *)
311 die "${FUNCNAME}: Unknown parameter"
312 ;;
313 esac
314 echo "${rvalue[@]}"
315}
316
317# @FUNCTION: phase_hook
318# @USAGE: <prefix>
319# Looks for functions named <prefix>_caller_suffix and executes them.
320# _caller_suffix is the calling function with the prefix
321# gtk-sharp-module removed.
322phase_hook() {
323 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs one argument"
324 if [[ "$(type -t ${1}${FUNCNAME[1]#gtk-sharp-module})" = "function" ]]
325 then
326 ebegin "Phase-hook: Running ${1}${FUNCNAME[1]#gtk-sharp-module}"
327 ${1}${FUNCNAME[1]#gtk-sharp-module}
328 eend 0
196fi 329 fi
330}
197 331
332# @FUNCTION: ac_path_prog_override
333# @USAGE: <PROG> [path]
334# @DESCRIPTION:
335# Override AC_PATH_PROG() autoconf macros. Path will be set to " " if
336# not specified.
337ac_path_prog_override() {
338 if [[ ${#@} -lt 1 || ${#@} -gt 2 ]]
339 then
340 eerror "${FUNCNAME[0]} requires at least one parameter and takes at most two:"
341 eerror "AC_PATH_PROG(PARAM1, param2)"
342 die "${FUNCNAME[0]} requires at least one parameter and takes at most two:"
343 fi
344 export ac_cv_path_${1}="${2:- }"
345}
198 346
199### Public functions.
200 347
201gtk-sharp-module_fix_files() { 348# @FUNCTION: pkg_check_modules_override
202 # Change references like "/r:../art/art-sharp.dll" -> 349# @USAGE: <GROUP> [package1] [package2]
203 # "/r:/usr/lib/pkgconfig/../../lib/mono/gtk-sharp-2.0/art-sharp.dll" and references like 350# @DESCRIPTION:
204 # "../glib/glib-sharp.xml" or "$(top_srcdir)/glib/glib-sharp.xml" -> 351# Will export the appropriate variables to override PKG_CHECK_MODULES autoconf
205 # "${gapi_dir}/glib-sharp.xml". 352# macros, with the string " " by default. If packages are specified, they will
206 # 353# be looked up with pkg-config and the appropriate LIBS and CFLAGS substituted.
207 # We also make sure to call the installed gapi-fixup and gapi-codegen and 354# LIBS and CFLAGS can also be specified per-package with the following syntax:
208 # not the ones that would be built locally. 355# @CODE
209 local gapi_dir="${ROOT}/usr/share/gapi${GTK_SHARP_SLOT_DEC}" 356# package=LIBS%CFLAGS
210 local GAPI_FIXUP="gapi2-fixup" 357# @CODE
211 local GAPI_CODEGEN="gapi2-codegen" 358# = and % have no effect unless both are specified.
359# Here is an example:
360# @CODE
361# pkg_check_modules_override GASH "gtk+-2.0=-jule%" gobject-2.0
362# @CODE
363# The above example will do:
364# export GASH_CFLAGS+=" -jule"
365# export GASH_LIBS+=" "
366# export GASH_CFLAGS+=" $(pkg-config --cflags gobject-2.0)"
367# export GASH_LIBS+=" $(pkg-config --libs gobject-2.0)"
368#
369# NOTE: If a package is not found, the string " " will be inserted in place of
370# <GROUP>_CFLAGS and <GROUP>_LIBS
371pkg_check_modules_override() {
372 local package
373 local group="${1}"
374 local packages="${*:2}"
375 export ${group}_CFLAGS=" "
376 export ${group}_LIBS=" "
212 377
213 local makefiles=( $(find "${S}" -name Makefile.in) ) 378 if [[ ${#@} -lt 1 ]]
379 then
380 eerror "${FUNCNAME[0]} requires at least one parameter: GROUP"
381 eerror "PKG_CHECK_MODULES(GROUP, package1 package2 etc)"
382 die "${FUNCNAME[0]} requires at least one parameter: GROUP"
383 fi
384
385 for package in $packages
386 do
387 if [[ ${package/=} != ${package} && ${package/\%} != ${package} ]]
388 then
389 package_cflag_libs=${package##*=}
390 export ${group}_CFLAGS+=" ${package_cflag_libs%%\%*}"
391 export ${group}_LIBS+=" ${package_cflag_libs##*\%}"
392 else
393 if pkg-config --exists $package
394 then
395 export ${group}_CFLAGS+=" $(pkg-config --cflags $package)"
396 export ${group}_LIBS+=" $(pkg-config --libs $package)"
397 else
398 export ${group}_CFLAGS+=" "
399 export ${group}_LIBS+=" "
400 fi
401 fi
402 done
403}
404
405# @FUNCTION: gtk-sharp-tarball-post_src_prepare
406# @DESCRIPTION:
407# Runs a M-m-m-monster sed on GTK_SHARP_MODULE_DIR to convert references to
408# local assemblies to the installed ones. Is only called by src_prepare when
409# $GTK_SHARP_MODULE is a member of $gtk_sharp_module_list.
410gtk-sharp-tarball-post_src_prepare() {
411 cd "${S}/${GTK_SHARP_MODULE_DIR}"
214 sed -i \ 412 sed -i \
215 -e "s;\(\.\.\|\$(top_srcdir)\|\$(srcdir)/\.\.\)/[[:alpha:]]*/\([[:alpha:]]*\(-[[:alpha:]]*\)*\).xml;${gapi_dir}/\2.xml;g" \ 413 -e "s; \$(srcdir)/../glib/glib-api.xml; $(get_sharp_apis --bare glib-sharp-2.0);" \
414 -e "s; ../pango/pango-api.xml; $(get_sharp_apis --bare pango-sharp-2.0);" \
415 -e "s; ../atk/atk-api.xml; $(get_sharp_apis --bare atk-sharp-2.0);" \
416 -e "s; ../gdk/gdk-api.xml; $(get_sharp_apis --bare gdk-sharp-2.0);" \
417 -e "s; ../gtk/gtk-api.xml; $(get_sharp_apis --bare gtk-sharp-2.0);" \
216 -e "s; \.\./glib/glib-sharp.dll; $(get_sharp_lib glib-sharp-2.0);g" \ 418 -e "s; \.\./glib/glib-sharp.dll; $(get_sharp_assemblies --bare glib-sharp-2.0);g" \
217 -e "s; \.\./pango/pango-sharp.dll; $(get_sharp_lib pango-sharp-2.0);g" \ 419 -e "s; \.\./pango/pango-sharp.dll; $(get_sharp_assemblies --bare pango-sharp-2.0);g" \
218 -e "s; \.\./art/art-sharp.dll; $(get_sharp_lib art-sharp-2.0);g" \
219 -e "s; \.\./atk/atk-sharp.dll; $(get_sharp_lib atk-sharp-2.0);g" \ 420 -e "s; \.\./atk/atk-sharp.dll; $(get_sharp_assemblies --bare atk-sharp-2.0);g" \
220 -e "s; \.\./gdk/gdk-sharp.dll; $(get_sharp_lib gdk-sharp-2.0);g" \ 421 -e "s; \.\./gdk/gdk-sharp.dll; $(get_sharp_assemblies --bare gdk-sharp-2.0);g" \
221 -e "s; \.\./gtk/gtk-sharp.dll; $(get_sharp_lib gtk-sharp-2.0);g" \ 422 -e "s; \.\./gtk/gtk-sharp.dll; $(get_sharp_assemblies --bare gtk-sharp-2.0);g" \
222 -e "s;\.\./gnomevfs/gnome-vfs-sharp.dll;$(get_sharp_lib gnome-vfs-sharp-2.0);g" \
223 -e "s;\$(top_builddir)/art/art-sharp.dll;$(get_sharp_lib art-sharp-2.0);" \
224 -e "s;\$(top_builddir)/gnome/gnome-sharp.dll;$(get_sharp_lib gnome-sharp-2.0);" \
225 -e "s;\$(RUNTIME) \$(top_builddir)/parser/gapi-fixup.exe;${GAPI_FIXUP};" \ 423 -e "s;\$(RUNTIME) \$(top_builddir)/parser/gapi-fixup.exe;/usr/bin/gapi2-fixup;" \
226 -e "s;\$(RUNTIME) \$(top_builddir)/generator/gapi_codegen.exe;${GAPI_CODEGEN};" \ 424 -e "s;\$(RUNTIME) \$(top_builddir)/generator/gapi_codegen.exe;/usr/bin/gapi2-codegen;" \
227 -e "s:\$(SYMBOLS) \$(top_builddir)/parser/gapi-fixup.exe:\$(SYMBOLS):" \ 425 -e "s:\$(SYMBOLS) \$(top_builddir)/parser/gapi-fixup.exe:\$(SYMBOLS):" \
228 -e "s:\$(INCLUDE_API) \$(top_builddir)/generator/gapi_codegen.exe:\$(INCLUDE_API):" \ 426 -e "s:\$(INCLUDE_API) \$(top_builddir)/generator/gapi_codegen.exe:\$(INCLUDE_API):" \
229 "${makefiles[@]}" || die "failed to fix GtkSharp makefiles" 427 $(find . -name Makefile.in) || die "failed to fix ${TARBALL}-tarball makefiles"
230} 428}
231 429
232get_sharp_lib() { 430# @FUNCTION: gnome-sharp-tarball-post_src_prepare
233 S="$(pkg-config --libs ${1})" 431# @DESCRIPTION:
234 S=${S%% *} 432# Runs a M-m-m-monster sed on GTK_SHARP_MODULE_DIR to convert references to
235 printf ${S#-r:} 433# local assemblies to the installed ones. Is only called by src_prepare when
236} 434# $GTK_SHARP_MODULE is a member of $gnome_sharp_module_list.
237
238gtk-sharp_tarball_src_prepare() {
239 local package
240 sed -i -e '/SUBDIRS/s/ glib / /' \
241 -e '/SUBDIRS/s/ glade / /' \
242 -e '/SUBDIRS/s/ sample / /' \
243 -e '/SUBDIRS/s/ doc/ /' \
244 Makefile.am || die "failed sedding sense into gtk-sharp's Makefile.am"
245 for package in GLIB PANGO ATK GTK
246 do
247 sed -r -i -e "s:(PKG_CHECK_MODULES\(${package}.*)\):\1,[foo=bar],[bar=foo]):" \
248 configure.in || die "failed sedding sense into gnome-sharp's configure.in"
249 done
250 EAUTORECONF=YES
251}
252
253gnome-sharp_tarball_src_prepare() { 435gnome-sharp-tarball-post_src_prepare() {
254 if ! [[ "${PN}" = "gconf-sharp" ]] 436 cd "${S}/${GTK_SHARP_MODULE_DIR}"
255 then 437 sed -i \
256 sed -r -i -e "s:(PKG_CHECK_MODULES\(GLADESHARP.*)\):\1,[foo=bar],[bar=foo]):" \ 438 -e "s; ../gnomevfs/gnome-vfs-api.xml; $(get_sharp_apis --bare gnome-vfs-sharp-2.0);" \
257 configure.in || die "failed sedding sense into gnome-sharp's configure.in" 439 -e "s; ../art/art-api.xml; $(get_sharp_apis --bare art-sharp-2.0);" \
258 EAUTORECONF=YES 440 -e "s; \.\./art/art-sharp.dll; $(get_sharp_assemblies --bare art-sharp-2.0);g" \
259 fi 441 -e "s; \.\./gnomevfs/gnome-vfs-sharp.dll; $(get_sharp_assemblies --bare gnome-vfs-sharp-2.0);g" \
442 -e "s;/r:\$(top_builddir)/art/art-sharp.dll;$(get_sharp_assemblies --prefixed art-sharp-2.0);" \
443 -e "s;/r:\$(top_builddir)/gnome/gnome-sharp.dll;$(get_sharp_assemblies --prefixed gnome-sharp-2.0);" \
444 $(find . -name Makefile.in) || die "failed to fix ${TARBALL}-tarball makefiles"
260} 445}
261 446
447# @FUNCTION: gtk-sharp-module_src_prepare
448# @DESCRIPTION:
449# Runs autopatch from base.eclass, eautoreconf if EAUTORECONF is set to any
450# value.
451# Contains a phase_hook, runs very last.
452# phase_hook prefix trigger: ${TARBALL}-tarball-post
453# Is exported.
262gtk-sharp-module_src_prepare() { 454gtk-sharp-module_src_prepare() {
263 if [[ "$(type -t $(gsm_get_tarball)_tarball_src_prepare)" = "function" ]]
264 then
265 ebegin "Running $(gsm_get_tarball)_tarball_src_prepare"
266 $(gsm_get_tarball)_tarball_src_prepare
267 eend $?
268 fi
269 base_src_util autopatch 455 base_src_util autopatch
270 456# @ECLASS-VARIABLE: EAUTORECONF
457# @DESCRIPTION:
458# If set, EAUTORECONF will be run during src_prepare.
271 [[ ${EAUTORECONF} ]] && eautoreconf 459 [[ ${EAUTORECONF} ]] && eautoreconf
272 460 phase_hook ${TARBALL}-tarball-post
273 cd "${S}/${GTK_SHARP_MODULE_DIR}" 461 elibtoolize
274
275 gtk-sharp-module_fix_files &> /dev/null
276} 462}
277 463
464# @FUNCTION: gtk-sharp-tarball_src_configure
465# @DESCRIPTION:
466# Sets some environment variables that will allow us to make the dependencies
467# for each ebuild be only its own dependencies, without patching configure.
468# Is only called by gtk-sharp-module_src_configure when $GTK_SHARP_MODULE
469# is a member of $gtk_sharp_module_list.
470gtk-sharp-tarball_src_configure() {
471 pkg_check_modules_override GLIB gobject-2.0
472 pkg_check_modules_override GIO gio-2.0
473 pkg_check_modules_override PANGO pango
474 pkg_check_modules_override ATK atk
475 pkg_check_modules_override GTK gtk+-2.0
476 pkg_check_modules_override GLADE libglade-2.0
477}
478
479# @FUNCTION: gnome-sharp-tarball_src_configure
480# @DESCRIPTION:
481# Sets some environment variables that will allow us to make the dependencies
482# for each ebuild be only its own dependencies. Without patching configure.
483# Is only called by gtk-sharp-module_src_configure when $GTK_SHARP_MODULE
484# is a member of $gnome_sharp_module_list.
485gnome-sharp-tarball_src_configure() {
486 pkg_check_modules_override GLADESHARP glade-sharp-2.0
487 pkg_check_modules_override GAPI gapi-2.0
488 ac_path_prog_override GAPI_PARSER /usr/bin/gapi2-parser
489 ac_path_prog_override GAPI_CODEGEN /usr/bin/gapi2-codegen
490 ac_path_prog_override GAPI_FIXUP /usr/bin/gapi2-fixup
491}
492
493# @FUNCTION: gtk-sharp-module_src_configure
494# @USAGE: [econf-arguments]
495# @DESCRIPTION:
496# Calls econf with some default values.
497# Contains a phase_hook, run before econf.
498# phase_hook prefix trigger: ${TARBALL}-tarball
499# Is exported.
278gtk-sharp-module_src_configure() { 500gtk-sharp-module_src_configure() {
501 phase_hook ${TARBALL}-tarball
279 econf --disable-static \ 502 econf --disable-static \
280 --disable-dependency-tracking \ 503 --disable-dependency-tracking \
281 --disable-maintainer-mode \ 504 --disable-maintainer-mode \
282 $(use debug &&echo "--enable-debug" ) \ 505 $(use debug &&echo "--enable-debug" ) \
283 ${gtk_sharp_conf} \
284 ${@} || die "econf failed" 506 ${@} || die "econf failed"
285} 507}
286 508
509# @FUNCTION: gtk-sharp-module_src_compile
510# @DESCRIPTION:
511# Calls emake in the subdir of the module.
512# Sets CSC=/usr/bin/gmcs. Deletes top_srcdir Makefiles to prevent recursing in
513# case we missed some dll references.
514# Is exported.
287gtk-sharp-module_src_compile() { 515gtk-sharp-module_src_compile() {
516 rm -f "${S}"/Makefile* &> /dev/null
288 cd "${S}/${GTK_SHARP_MODULE_DIR}" 517 cd "${S}/${GTK_SHARP_MODULE_DIR}"
289 emake || die "emake failed" 518 emake CSC=/usr/bin/gmcs || die "emake failed"
290} 519}
291 520
521# @FUNCTION: gtk-sharp-module_src_install
522# @DESCRIPTION:
523# Installs the module. Fixes up lib paths so they're multilib-safe.
524# Gets rid of .la files.
525# Is exported.
292gtk-sharp-module_src_install() { 526gtk-sharp-module_src_install() {
293
294 cd "${GTK_SHARP_MODULE_DIR}" 527 cd "${S}/${GTK_SHARP_MODULE_DIR}"
295 emake DESTDIR=${D} install || die "emake install failed" 528 emake DESTDIR="${D}" install || die "emake install failed"
296 mono_multilib_comply 529 mono_multilib_comply
297 find "${D}" -name '*.la' -exec rm -rf '{}' '+' || die "la removal failed" 530 find "${D}" -type f -name '*.la' -exec rm -rf '{}' '+' || die "la removal failed"
298 if has "${GTK_SHARP_MODULE}" gtk gdk atk pango 531 [[ $(find "${D}" -type f|wc -l) -lt 3 ]] && die "Too few files. This smells like a failed install."
299 then
300 find "${D}" -name '*.pc' -exec rm -rf '{}' '+' || die "la removal failed"
301 pkgconfig_filename="${PN}${GTK_SHARP_SLOT_DEC}"
302 pkgconfig_pkgname="${GTK_SHARP_MODULE}#"
303 pkgconfig_description=".NET/Mono bindings for ${GTK_SHARP_MODULE}"
304 pkgconfig_monodir="$(gsm_get_tarball)${GTK_SHARP_SLOT_DEC}"
305 case ${GTK_SHARP_MODULE} in
306 gtk)
307 pkgconfig_requires="glib-sharp${GTK_SHARP_SLOT_DEC} atk-sharp${GTK_SHARP_SLOT_DEC} gdk-sharp${GTK_SHARP_SLOT_DEC} pango-sharp${GTK_SHARP_SLOT_DEC}"
308 ;;
309 gdk)
310 pkgconfig_requires="glib-sharp${GTK_SHARP_SLOT_DEC} pango-sharp${GTK_SHARP_SLOT_DEC}"
311 ;;
312 atk)
313 pkgconfig_requires="glib-sharp${GTK_SHARP_SLOT_DEC}"
314 ;;
315 pango)
316 pkgconfig_requires="glib-sharp${GTK_SHARP_SLOT_DEC}"
317 ;;
318 *)
319 die "unhandled gtk_sharp_module"
320 ;;
321 esac
322 generate_pkgconfig
323 fi
324} 532}
325 533
326EXPORT_FUNCTIONS src_prepare src_configure src_compile src_install 534EXPORT_FUNCTIONS src_prepare src_configure src_compile src_install
327
328generate_pkgconfig() {
329 ebegin "Generating .pc file for ${P}"
330 local dll \
331 gfile \
332 pkgconfig_gapidir \
333 apifile \
334 LSTRING='Libs:' \
335 CSTRING='Cflags:' \
336 pkgconfig_filename="${1:-${pkgconfig_filename:-${PN}}}" \
337 pkgconfig_monodir="${2:-${pkgconfig_monodir:-${pkgconfig_filename}}}" \
338 pkgconfig_pkgname="${3:-${pkgconfig_pkgname:-${pkgconfig_filename}}}" \
339 pkgconfig_version="${4:-${pkgconfig_version:-${PV}}}" \
340 pkgconfig_description="${5:-${pkgconfig_description:-${DESCRIPTION}}}" \
341 pkgconfig_requires="${6:-${pkgconfig_requires}}" \
342
343 pushd "${D}/usr/" &> /dev/null
344 apifile=$(find share -name '*-api.xml' 2>/dev/null)
345 popd &> /dev/null
346
347 pkgconfig_gapidir=${apifile:+\$\{prefix\}/${apifile%/*}}
348
349 dodir "/usr/$(get_libdir)/pkgconfig"
350 cat <<- EOF -> "${D}/usr/$(get_libdir)/pkgconfig/${pkgconfig_filename}.pc"
351 prefix=\${pcfiledir}/../..
352 exec_prefix=\${prefix}
353 libdir=\${prefix}/$(get_libdir)
354 gapidir=${pkgconfig_gapidir}
355 Name: ${pkgconfig_pkgname}
356 Description: ${pkgconfig_description}
357 Version: ${pkgconfig_version}
358 EOF
359
360 for gfile in "${D}"/usr/${apifile%/*}/*-api.xml
361 do
362 CSTRING="${CSTRING} -I:"'${gapidir}'"/${gfile##*/}"
363 done
364 echo "${CSTRING}" >> "${D}/usr/$(get_libdir)/pkgconfig/${pkgconfig_filename}.pc"
365
366
367 for dll in "${D}"/usr/$(get_libdir)/mono/${pkgconfig_monodir}/*.dll
368 do
369 if ! [[ "${dll##*/}" == "policy."*".dll" ]]
370 then
371 LSTRING="${LSTRING} -r:"'${libdir}'"/mono/${pkgconfig_monodir}/${dll##*/}"
372 fi
373 done
374 echo "${LSTRING}" >> "${D}/usr/$(get_libdir)/pkgconfig/${pkgconfig_filename}.pc"
375
376 if [[ "${pkgconfig_requires}" ]]
377 then
378 printf "Requires: ${pkgconfig_requires}" >> "${D}/usr/$(get_libdir)/pkgconfig/${pkgconfig_filename}.pc"
379 fi
380 PKG_CONFIG_PATH="${D}/usr/$(get_libdir)/pkgconfig/" pkg-config --silence-errors --libs ${pkgconfig_filename} &> /dev/null
381 eend $?
382}
383

Legend:
Removed from v.1.9  
changed lines
  Added in v.1.25

  ViewVC Help
Powered by ViewVC 1.1.20